CUDNN Frontend API 8.3.0

Public Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
cudnn_frontend::ConvDesc_v8 Class Reference

`#include <cudnn_frontend_ConvDesc.h>`

Inheritance diagram for cudnn_frontend::ConvDesc_v8:
Collaboration diagram for cudnn_frontend::ConvDesc_v8:

## Public Member Functions
std::string | describe () const override
| Return a string describing the backend Descriptor. More...
| ConvDesc_v8 (ConvDesc_v8 &&from)=default
ConvDesc_v8 & | operator= (ConvDesc_v8 &&)=default
| ~ConvDesc_v8 ()=default
cudnnDataType_t | getComputePrecision () const
int64_t | getDimensionCount () const
int64_t const * | getPadding () const
int64_t const * | getStride () const
int64_t const * | getDilation () const
cudnnConvolutionMode_t | getMathMode () const
Public Member Functions inherited from cudnn_frontend::BackendDescriptor
cudnnBackendDescriptor_t | get_raw_desc () const
cudnnStatus_t | get_status () const
| Current status of the descriptor. More...
void | set_status (cudnnStatus_t const status_) const
| Set status of the descriptor. More...
void | set_error (const char *message) const
| Set Diagonistic error message. More...
const char * | get_error () const
| Diagonistic error message if any. More...
ManagedOpaqueDescriptor | get_desc () const
| Returns a copy of underlying managed descriptor. More...
cudnnStatus_t | initialize_managed_backend_pointer (cudnnBackendDescriptorType_t type)
| Initializes the underlying managed descriptor. More...

## Private Member Functions
| ConvDesc_v8 ()=default
| ConvDesc_v8 (ConvDesc_v8 const &)=delete
ConvDesc_v8 & | operator= (ConvDesc_v8 const &)=delete

## Private Attributes
cudnnDataType_t | compute_precision = CUDNN_DATA_FLOAT
cudnnConvolutionMode_t | mode = CUDNN_CONVOLUTION
| Convolution operation data type. More...
int64_t | nDims = -1
| Convolution vs cross correlation. More...
int64_t | padLower [CUDNN_DIM_MAX+1] = {0}
| number of dimensions More...
int64_t | padUpper [CUDNN_DIM_MAX+1] = {0}
| d, h, w More...
int64_t | dilation [CUDNN_DIM_MAX+1] = {0}
| d, h, w More...
int64_t | stride [CUDNN_DIM_MAX+1] = {-1}
| d, h, w More...

## Friends
class | ConvDescBuilder_v8

## Additional Inherited Members
Protected Member Functions inherited from cudnn_frontend::BackendDescriptor
| BackendDescriptor (ManagedOpaqueDescriptor pointer_, cudnnStatus_t status_, std::string err_msg_)
| BackendDescriptor ()=default
Protected Attributes inherited from cudnn_frontend::BackendDescriptor
ManagedOpaqueDescriptor | pointer
cudnnStatus_t | status = CUDNN_STATUS_SUCCESS
| Shared pointer of the OpaqueBackendPointer. More...
std::string | err_msg
| Error message if any being set. More...

## Detailed Description

Convolution Descriptor Class This class tells the properties of the Convolution operation Properties:

- padLower
- padUpper
- Dilation
- Stride
- Math Operation Data Type
- Convolution Mode
- Convolution spatial dimensions

Use ConvDescBuilder_v8 to build this class. Describe returns a string describing the convolution operation

Definition at line 54 of file cudnn_frontend_ConvDesc.h.

## Constructor & Destructor Documentation

## ◆ ConvDesc_v8() [1/3]

cudnn_frontend::ConvDesc_v8::ConvDesc_v8 | ( | ConvDesc_v8 && | from | ) |
| default

## ◆ ~ConvDesc_v8()

cudnn_frontend::ConvDesc_v8::~ConvDesc_v8 | ( |  | ) |
| default

Referenced by describe().

## ◆ ConvDesc_v8() [2/3]

cudnn_frontend::ConvDesc_v8::ConvDesc_v8 | ( |  | ) |
| privatedefault

Referenced by describe(), and getMathMode().

## ◆ ConvDesc_v8() [3/3]

cudnn_frontend::ConvDesc_v8::ConvDesc_v8 | ( | ConvDesc_v8 const & |  | ) |
| privatedelete

## Member Function Documentation

## ◆ describe()

std::string cudnn_frontend::ConvDesc_v8::describe | ( |  | ) | const
| inlineoverridevirtual

Return a string describing the backend Descriptor.

Implements cudnn_frontend::BackendDescriptor.

Definition at line 58 of file cudnn_frontend_ConvDesc.h.

References compute_precision, ConvDesc_v8(), dilation, mode, nDims, operator=(), padLower, padUpper, stride, cudnn_frontend::to_string(), nlohmann::to_string(), and ~ConvDesc_v8().

## ◆ getComputePrecision()

cudnnDataType_t cudnn_frontend::ConvDesc_v8::getComputePrecision | ( |  | ) | const
| inline

Definition at line 95 of file cudnn_frontend_ConvDesc.h.

References compute_precision.

## ◆ getDilation()

int64_t const* cudnn_frontend::ConvDesc_v8::getDilation | ( |  | ) | const
| inline

Definition at line 113 of file cudnn_frontend_ConvDesc.h.

References dilation.

## ◆ getDimensionCount()

int64_t cudnn_frontend::ConvDesc_v8::getDimensionCount | ( |  | ) | const
| inline

Definition at line 100 of file cudnn_frontend_ConvDesc.h.

References nDims.

Referenced by cudnn_frontend::cudnnReorderFilterAndBiasInt8x32().

## ◆ getMathMode()

cudnnConvolutionMode_t cudnn_frontend::ConvDesc_v8::getMathMode | ( |  | ) | const
| inline

Definition at line 118 of file cudnn_frontend_ConvDesc.h.

References ConvDesc_v8(), mode, and operator=().

## ◆ getPadding()

int64_t const* cudnn_frontend::ConvDesc_v8::getPadding | ( |  | ) | const
| inline

Definition at line 105 of file cudnn_frontend_ConvDesc.h.

References padLower.

## ◆ getStride()

int64_t const* cudnn_frontend::ConvDesc_v8::getStride | ( |  | ) | const
| inline

Definition at line 109 of file cudnn_frontend_ConvDesc.h.

References stride.

## ◆ operator=() [1/2]

ConvDesc_v8& cudnn_frontend::ConvDesc_v8::operator= | ( | ConvDesc_v8 && |  | ) |
| default

Referenced by cudnn_frontend::ConvDescBuilder_v8::build(), describe(), and getMathMode().

## ◆ operator=() [2/2]

ConvDesc_v8& cudnn_frontend::ConvDesc_v8::operator= | ( | ConvDesc_v8 const & |  | ) |
| privatedelete

## Friends And Related Function Documentation

## ◆ ConvDescBuilder_v8

friend class ConvDescBuilder_v8
| friend

Definition at line 56 of file cudnn_frontend_ConvDesc.h.

Referenced by cudnn_frontend::ConvDescBuilder_v8::build().

## Member Data Documentation

## ◆ compute_precision

cudnnDataType_t cudnn_frontend::ConvDesc_v8::compute_precision = CUDNN_DATA_FLOAT
| private

Definition at line 129 of file cudnn_frontend_ConvDesc.h.

Referenced by describe(), and getComputePrecision().

## ◆ dilation

int64_t cudnn_frontend::ConvDesc_v8::dilation[CUDNN_DIM_MAX+1] = {0}
| private

d, h, w

Definition at line 134 of file cudnn_frontend_ConvDesc.h.

Referenced by describe(), getDilation(), and cudnn_frontend::ConvDescBuilder_v8::setDilation().

## ◆ mode

cudnnConvolutionMode_t cudnn_frontend::ConvDesc_v8::mode = CUDNN_CONVOLUTION
| private

Convolution operation data type.

Definition at line 130 of file cudnn_frontend_ConvDesc.h.

Referenced by describe(), and getMathMode().

## ◆ nDims

int64_t cudnn_frontend::ConvDesc_v8::nDims = -1
| private

Convolution vs cross correlation.

Definition at line 131 of file cudnn_frontend_ConvDesc.h.

Referenced by describe(), and getDimensionCount().

## ◆ padLower

int64_t cudnn_frontend::ConvDesc_v8::padLower[CUDNN_DIM_MAX+1] = {0}
| private

number of dimensions

Definition at line 132 of file cudnn_frontend_ConvDesc.h.

Referenced by describe(), and getPadding().

## ◆ padUpper

int64_t cudnn_frontend::ConvDesc_v8::padUpper[CUDNN_DIM_MAX+1] = {0}
| private

d, h, w

Definition at line 133 of file cudnn_frontend_ConvDesc.h.

Referenced by describe().

## ◆ stride

int64_t cudnn_frontend::ConvDesc_v8::stride[CUDNN_DIM_MAX+1] = {-1}
| private

d, h, w

Definition at line 135 of file cudnn_frontend_ConvDesc.h.

Referenced by describe(), and getStride().

The documentation for this class was generated from the following file:

- cudnn_frontend_ConvDesc.h